' ###########################################################
' #								      #
' # 	         	    Pseudo out-of-sample forecasting		      #
' #								      #
' ###########################################################



' CREATION OF WORKFILE AND READING OF DATA
' ***************************************************************

wfcreate(wf=emoney, page=monthly) m 1997m09 2008m05
read(a2, s=sheet1) "c:\Progs\ch3\dataset\emoney.xls" 17

tot_m2.hpf(lambda=14400) tot_m2_hp

' DECLARATION OF WILDCARDS
' ***************************************

!n_mod = 28	' no. component models
!t = 117		' sample length
!h = 12		' forecast hoirzon
!tt = !t + !h	' sample length + forecast horizon

sample short.set 1997m09 2007m05
sample for.set 2007m06 2008m05
sample long.set 1997m09 2008m05


' ESTIMATION OF COMPONENT MODELS
' *************************************************

' Benchmark geometric random walk model

smpl short
equation grwd.ls log(tot_m2_hp) c ar(1)
smpl for
grwd.forecast grwd_f grwd_se
smpl @all
graph grwd_gr.line tot_m2_hp grwd_f
	grwd_gr.draw(line, bottom) 2007:5
smpl 2006m5 2008m5
graph grwd_gr2.line tot_m2_hp grwd_f
	grwd_gr2.draw(line, bottom) 2007:5

' AR(p) models

' AR(2)
smpl short
equation ar2.ls log(tot_m2_hp) c ar(1) ar(2)
smpl for
ar2.forecast ar2_f ar2_se

' AR(3)
smpl short
equation ar3.ls log(tot_m2_hp) c ar(1) ar(2) ar(3)
smpl for
ar3.forecast ar3_f ar3_se

' AR(4)
smpl short
equation ar4.ls log(tot_m2_hp) c ar(1) ar(2) ar(3) ar(4)
smpl for
ar4.forecast ar4_f ar4_se


' MA(q) models

' MA(1)
smpl short
equation ma1.ls log(tot_m2_hp) c ma(1)
smpl for
ma1.forecast ma1_f ma1_se

' MA(2)
smpl short
equation ma2.ls log(tot_m2_hp) c ma(1) ma(2)
smpl for
ma2.forecast ma2_f ma2_se

' MA(3)
smpl short
equation ma3.ls log(tot_m2_hp) c ma(1) ma(2) ma(3)
smpl for
ma3.forecast ma3_f ma3_se

' MA(4)
smpl short
equation ma4.ls log(tot_m2_hp) c ma(1) ma(2) ma(3) ma(4)
smpl for
ma4.forecast ma4_f ma4_se


' ARIMA(p,d,q) models

' ARIMA(1,1,1)
smpl short
equation arima111.ls d(log(tot_m2_hp)) c ar(1) ma(1)
smpl for
arima111.forecast arima111_f arima111_se

' ARIMA(1,1,2)
smpl short
equation arima112.ls d(log(tot_m2_hp)) c ar(1) ma(1) ma(2)
smpl for
arima112.forecast arima112_f arima112_se

' ARIMA(1,1,3)
smpl short
equation arima113.ls d(log(tot_m2_hp)) c ar(1) ma(1) ma(2) ma(3)
smpl for
arima113.forecast arima113_f arima113_se

' ARIMA(1,1,4)
smpl short
equation arima114.ls d(log(tot_m2_hp)) c ar(1) ma(1) ma(2) ma(3) ma(4)
smpl for
arima114.forecast arima114_f arima114_se

' ARIMA(2,1,1)
smpl short
equation arima211.ls d(log(tot_m2_hp)) c ar(1) ar(2) ma(1)
smpl for
arima211.forecast arima211_f arima211_se

' ARIMA(2,1,2)
smpl short
equation arima212.ls d(log(tot_m2_hp)) c ar(1) ar(2) ma(1) ma(2)
smpl for
arima212.forecast arima212_f arima212_se

' ARIMA(2,1,3)
smpl short
equation arima213.ls d(log(tot_m2_hp)) c ar(1) ar(2) ma(1) ma(2) ma(3)
smpl for
arima213.forecast arima213_f arima213_se

' ARIMA(2,1,4)
smpl short
equation arima214.ls d(log(tot_m2_hp)) c ar(1) ar(2) ma(1) ma(2) ma(3) ma(4)
smpl for
arima214.forecast arima214_f arima214_se

' ARIMA(3,1,1)
smpl short
equation arima311.ls d(log(tot_m2_hp)) c ar(1) ar(2) ar(3) ma(1)
smpl for
arima311.forecast arima311_f arima311_se

' ARIMA(3,1,2)
smpl short
equation arima312.ls d(log(tot_m2_hp)) c ar(1) ar(2) ar(3) ma(1) ma(2)
smpl for
arima312.forecast arima312_f arima312_se

' ARIMA(3,1,3)
smpl short
equation arima313.ls d(log(tot_m2_hp)) c ar(1) ar(2) ar(3) ma(1) ma(2) ma(3)
smpl for
arima313.forecast arima313_f arima313_se

' ARIMA(3,1,4)
smpl short
equation arima314.ls d(log(tot_m2_hp)) c ar(1) ar(2) ar(3) ma(1) ma(2) ma(3) ma(4)
smpl for
arima314.forecast arima314_f arima314_se

' ARIMA(4,1,1)
smpl short
equation arima411.ls d(log(tot_m2_hp)) c ar(1) ar(2) ar(3) ar(4) ma(1)
smpl for
arima411.forecast arima411_f arima411_se

' ARIMA(4,1,2)
smpl short
equation arima412.ls d(log(tot_m2_hp)) c ar(1) ar(2) ar(3) ar(4) ma(1) ma(2)
smpl for
arima412.forecast arima412_f arima412_se

' ARIMA(4,1,3)
smpl short
equation arima413.ls d(log(tot_m2_hp)) c ar(1) ar(2) ar(3) ar(4) ma(1) ma(2) ma(3)
smpl for
arima413.forecast arima413_f arima413_se

' ARIMA(4,1,4)
smpl short
equation arima414.ls d(log(tot_m2_hp)) c ar(1) ar(2) ar(3) ar(4) ma(1) ma(2) ma(3) ma(4)
smpl for
arima414.forecast arima414_f arima414_se


' VAR(p) models

' VAR(1)
smpl short
var var1.ls 1 1 d(log(tot_m2_hp)) d(log(cur_m2)) d(log(dep_m2)) d(log(ip_ki)) d(log(ndq_ki)) d(log(r)) d(log(tec_i))
var1.makemodel(var1_mod)
var1_mod.scenario(n,a=_v1) "var1"
smpl for
var1_mod.solve (i=p,s=s)

' VAR(2)
smpl short
var var2.ls 1 2 d(log(tot_m2_hp)) d(log(cur_m2)) d(log(dep_m2)) d(log(ip_ki)) d(log(ndq_ki)) d(log(r)) d(log(tec_i))
var2.makemodel(var2_mod)
var2_mod.scenario(n,a=_v2) "var2"
smpl for
var2_mod.solve (i=p,s=s)

' VAR(3)
smpl short
var var3.ls 1 3 d(log(tot_m2_hp)) d(log(cur_m2)) d(log(dep_m2)) d(log(ip_ki)) d(log(ndq_ki)) d(log(r)) d(log(tec_i))
var3.makemodel(var3_mod)
var3_mod.scenario(n,a=_v3) "var3"
smpl for
var3_mod.solve (i=p,s=s)

' VAR(4)
smpl short
var var4.ls 1 4 d(log(tot_m2_hp)) d(log(cur_m2)) d(log(dep_m2)) d(log(ip_ki)) d(log(ndq_ki)) d(log(r)) d(log(tec_i))
var4.makemodel(var4_mod)
var4_mod.scenario(n,a=_v4) "var4"
smpl for
var4_mod.solve (i=p,s=s)


' VEC(p) models - trace stat indicates r=5

' VECM(1)
smpl short
var vec1.ec(d,5) 1 1 log(tot_m2_hp) log(cur_m2) log(dep_m2) log(ip_ki) log(ndq_ki) log(r) log(tec_i)
vec1.makemodel(vec1_mod)
vec1_mod.scenario(n,a=_vc1) "vec1"
smpl for
vec1_mod.solve (i=p,s=s)

' VECM(2)
smpl short
var vec2.ec(d,5) 1 2 log(tot_m2_hp) log(cur_m2) log(dep_m2) log(ip_ki) log(ndq_ki) log(r) log(tec_i)
vec2.makemodel(vec2_mod)
vec2_mod.scenario(n,a=_vc2) "vec2"
smpl for
vec2_mod.solve (i=p,s=s)

' VECM(3)
smpl short
var vec3.ec(d,5) 1 3 log(tot_m2_hp) log(cur_m2) log(dep_m2) log(ip_ki) log(ndq_ki) log(r) log(tec_i)
vec3.makemodel(vec3_mod)
vec3_mod.scenario(n,a=_vc3) "vec3"
smpl for
vec3_mod.solve (i=p,s=s)

' VECM(4)
smpl short
var vec4.ec(d,5) 1 4 log(tot_m2_hp) log(cur_m2) log(dep_m2) log(ip_ki) log(ndq_ki) log(r) log(tec_i)
vec4.makemodel(vec4_mod)
vec4_mod.scenario(n,a=_vc4) "vec4"
smpl for
vec4_mod.solve (i=p,s=s)


' COMPUTATION OF AVERAGE FORECAST
' ****************************************************

vector(!tt) for_1
	stom(grwd_f,for_1)
vector(!tt) for_2
	stom(ar2_f,for_2)
vector(!tt) for_3
	stom(ar3_f,for_3)
vector(!tt) for_4
	stom(ar4_f,for_4)

vector(!tt) for_5
	stom(arima111_f,for_5)
vector(!tt) for_6
	stom(arima112_f,for_6)
vector(!tt) for_7
	stom(arima113_f,for_7)
vector(!tt) for_8
	stom(arima114_f,for_8)

vector(!tt) for_9
	stom(arima211_f,for_9)
vector(!tt) for_10
	stom(arima212_f,for_10)
vector(!tt) for_11
	stom(arima213_f,for_11)
vector(!tt) for_12
	stom(arima214_f,for_12)

vector(!tt) for_13
	stom(arima311_f,for_13)
vector(!tt) for_14
	stom(arima312_f,for_14)
vector(!tt) for_15
	stom(arima313_f,for_15)
vector(!tt) for_16
	stom(arima314_f,for_16)

vector(!tt) for_17
	stom(arima411_f,for_17)
vector(!tt) for_18
	stom(arima412_f,for_18)
vector(!tt) for_19
	stom(arima413_f,for_19)
vector(!tt) for_20
	stom(arima414_f,for_20)

vector(!tt) for_21
	stom(tot_m2_hp_v1,for_21)
vector(!tt) for_22
	stom(tot_m2_hp_v2,for_22)
vector(!tt) for_23
	stom(tot_m2_hp_v3,for_23)
vector(!tt) for_24
	stom(tot_m2_hp_v4,for_24)

vector(!tt) for_25
	stom(tot_m2_hp_vc1,for_25)
vector(!tt) for_26
	stom(tot_m2_hp_vc2,for_26)
vector(!tt) for_27
	stom(tot_m2_hp_vc3,for_27)
vector(!tt) for_28
	stom(tot_m2_hp_vc4,for_28)

For !i=1 to !n_mod
matrix(!h,!n_mod) for_m
matplace(for_m,for_!i,1,!i)
Next

For !j = 1 to !h
vector(!h) for_mean_v
for_mean_v(!j)=@mean(@rowextract(for_m,!j))
Next

series for_mean=na
mtos(for_mean_v,for_mean)


' PLOTTING FORECAST GRAPHS
' ***************************************

smpl @all
graph ave_f_gr.line tot_m2_hp for_mean
	ave_f_gr.draw(line,bottom) 2007m5

smpl 2006m5 2008m5
graph ave_f_gr2.line tot_m2_hp for_mean
	ave_f_gr2.draw(line,bottom) 2007m5


' END OF PROGRAMME

